HDU 4081Qin Shi Huang's National Road System(最小生成树+最小瓶颈路)



题意:秦始皇要修路。把N个城市用N-1条边连通。且他希望花费最小,可是这时候有一个多管闲事的道士出来说他有魔法能够帮助秦始皇变成一条路。可是仅仅能变出一条。

可是。两个人对修路的法案存在歧义,道士希望修路能够给很多其它的百姓带来福利。而秦始皇希望修路要尽量使花费小。最后,秦始皇拿出了一个公式A/B。A表示两个城市的人数,B表示出了用魔法变出来的路外。最短的总距离。

如今要你求出A/B的最大值。

思路:枚举连接哪两个城市。由于这条边是免费的。我们要求算上这条边的最小生成树。假设每次都求一次最小生成树会超时,所以先跑一遍整个图的最小生成树。然后再预处理出这个mst上的随意两点之间路径的最大值,由于加入免费边时,去掉的就是这个最大边。这样一样时间复杂度降为O(n*n)。

#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<iostream>
#include<algorithm>
#include<vector>
#include<map>
#include<queue>
#include<stack>
#include<string>
#include<map>
#include<set>
#define eps 1e-6
#define LL long long
using namespace std;  

const int maxn = 1050;
const int maxm = maxn*maxn;
//const int INF = 0x3f3f3f3f;
vector<int> G[maxn];
int vis[maxn];
int n, m, ple[maxn], x[maxn], y[maxn];
int u[maxm], v[maxm], p[maxn], r[maxm];
double w[maxm], W[maxn][maxn], maxcost[maxn][maxn];;
bool cmp(const int i, const int j) {
	return w[i] < w[j];
}
int find(int x) {
	return p[x] == x ? x : p[x] = find(p[x]);
}
double Kruscal() {
	double ans = 0;
	for(int i = 0; i < n; i++) p[i] = i; //初始化并查集
	for(int i = 0; i < m; i++) r[i] = i; //初始化边序号
	sort(r, r+m, cmp);
	for(int i = 0; i < m; i++) {
		int e = r[i];
		int x = find(u[e]), y = find(v[e]);
		if(x != y) {
			ans += w[e];
			p[x] = y;
			G[u[e]].push_back(v[e]); G[v[e]].push_back(u[e]);
		}
	}
	return ans;
}
void init() {
	memset(vis, 0, sizeof(vis));
	for(int i = 0; i < n; i++) G[i].clear();
}
void dfs(int cur, int fa) {
	maxcost[cur][cur] = 0;
	if(fa != -1) {
		for(int i = 0; i < n; i++) if(vis[i]){
			maxcost[i][cur] = maxcost[cur][i] = max(maxcost[i][fa], W[fa][cur]);
		}
	}
	vis[cur] = 1;
	for(int i = 0; i < G[cur].size(); i++) {
		int u = G[cur][i];
		if(u == fa) continue;
		dfs(u, cur);
	}
}
int main() {
	//freopen("input.txt", "r", stdin);
	int T; cin >> T;
	while(T--) {
		cin >> n;
		for(int i = 0; i < n; i++) scanf("%d%d%d", &x[i], &y[i], &ple[i]);
		m = 0;
		for(int i = 0; i < n; i++) {
			for(int j = i+1; j < n; j++) {
				u[m] = i; v[m] = j;
				w[m] = sqrt((double)((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j])));
				W[i][j] = W[j][i] = w[m];
				m++;
			}
		}
		init();
		double mst = Kruscal();
		//cout << mst << endl;
		dfs(0, -1);
		double ans = 0;
		for(int i = 0; i < n; i++) {
			for(int j = i+1; j < n; j++) {
				ans = max(ans, (double)(ple[i]+ple[j])/(mst-maxcost[i][j]));
			}
		}
		printf("%.2lf\n", ans);
	}
	return 0;
}

HDU 4081Qin Shi Huang's National Road System(最小生成树+最小瓶颈路)

时间: 2024-08-25 09:59:43

HDU 4081Qin Shi Huang&#39;s National Road System(最小生成树+最小瓶颈路)的相关文章

HDU 4081 Qin Shi Huang&#39;s National Road System 最小生成树

分析:http://www.cnblogs.com/wally/archive/2013/02/04/2892194.html 这个题就是多一个限制,就是求包含每条边的最小生成树,这个求出原始最小生成树然后查询就好了 然后预处理那个数组是O(n^2)的,这样总时间复杂度是O(n^2+m) 这是因为这个题n比较小,如果n大的时候,就需要路径查询了,比如LCA 或者树链剖分达到O(mlogn) #include <iostream> #include <algorithm> #incl

HDU 4081 Qin Shi Huang&#39;s National Road System(最小生成树/次小生成树)

题目链接:传送门 题意: 有n坐城市,知道每坐城市的坐标和人口.现在要在所有城市之间修路,保证每个城市都能相连,并且保证A/B 最大,所有路径的花费和最小,A是某条路i两端城市人口的和,B表示除路i以外所有路的花费的和(路径i的花费为0). 分析: 先求一棵最小生成树,然后枚举每一条最小生成树上的边,删掉后变成两个生成树,然后找两个集合中点权最大的两 个连接起来.这两个点中必然有权值最大的那个点,所以直接从权值最大的点开始dfs. 为了使A/B的值最大,则A尽可能大,B尽可能小.所以B中的边一定

HDU 4081 Qin Shi Huang&#39;s National Road System(最小生成树+暴力枚举边)

题目大意:给你1000个点,每个点上有一个数目代表这个城市有多少人,让你把这N个点构成一颗生成树,你可以删除其中的任意一条边.让你求出一个比例A/B是的这个比例最大,A表示你删除那条边上两个城市的人口数之和,B表示的是去掉这条变这可生成树上其他的边的总长度. 解体思路:先求出来最小生成树,然后暴力枚举生成树的边,B=总数-这条边的长度.A = 将这条连断开之后左右集合中权值最大的两个数的和. 这样保证了B最小的情况下,去找最大的A,所以是可行的解.生成树的同时建边,然后dfs找最大值. PS:这

HDU 4081 Qin Shi Huang&#39;s National Road System 最小生成树+倍增求LCA

原题链接:http://acm.hdu.edu.cn/showproblem.php?pid=4081 Qin Shi Huang's National Road System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 5428    Accepted Submission(s): 1902 Problem Description

HDU 4081 Qin Shi Huang&#39;s National Road System

https://vjudge.net/problem/HDU-4081 题意: 秦始皇想要修长城,修成生成树的样子,这是一个大师出现了,他说他可以不耗费人力修出一条路来.他们的目的很不一样,神特么有分歧,最后他们达成了一个协议,假设一个城市的人口为a.那么最后不耗费人力修的那条路所相连的两个城市的人力之和A与修路花费的人力B之比 A/B最大,并且输出最大值. 思路: 枚举去掉每一条边. 首先求出最小生成树,对于最小生成树中的每一条边,如果这条边不花费人力,那么直接计算A和B就可以了. 那么问题是

hdu 4081 Qin Shi Huang&#39;s National Road System(最小生成树+dp)

同样是看别人题解才明白的 题目大意—— 话说秦始皇统一六国之后,打算修路.他要用n-1条路,将n个城市连接起来,并且使这n-1条路的距离之和最短.最小生成树是不是?不对,还有呢.接着,一个自称徐福的游方道士突然出现,他说他可以不消耗任何人力财力,使用法术凭空造一条路,路的长度无所谓,但是只能造一条.那么问题来了,徐福希望将两座人口数最多的城市连接起来,而秦始皇希望将最长的路修好.最后折中了一下, 将A/B最大的一条路用法术修出来.其中A是两座城市的人口和,B是除了用法术修的路以外,其它需要修建的

hdu 4081 Qin Shi Huang&#39;s National Road System (次小生成树)

Qin Shi Huang's National Road System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3843    Accepted Submission(s): 1336 Problem Description During the Warring States Period of ancient China(47

HDU 4081 Qin Shi Huang&#39;s National Road System 次小生成树变种

Qin Shi Huang's National Road System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) [Problem Description] During the Warring States Period of ancient China(476 BC to 221 BC), there were seven kingdoms in China ---

[hdu P4081] Qin Shi Huang’s National Road System

[hdu P4081] Qin Shi Huang’s National Road System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Problem Description During the Warring States Period of ancient China(476 BC to 221 BC), there were seven kingdoms in